//+------------------------------------------------------------------+
//|                                                 VininL_Trade.MQ4 |
//|                                Copyright  2010, Victor Nicolaev |
//|                                            e-mail: vinin@mail.ru |
//+------------------------------------------------------------------+
#property copyright "Copyright  2010, Victor Nicolaev"
#property link      "e-mail: vinin@mail.ru"

//      
//+------------------------------------------------------------------+
//|                                         |
//|                                Copyright  2010, Victor Nicolaev |
//|                                            e-mail: vinin@mail.ru |
// bool NevBar(Period());                                            |
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//|                        |
//|                                Copyright  2010, Victor Nicolaev |
//|                                            e-mail: vinin@mail.ru |
// int IdTimeFrame(Period());                                        |
//+------------------------------------------------------------------+



extern string  lib.VT_S             = " ";
extern double  lib.Lots           =  0.1  ;
extern double  lib.Risk           =  1  ;
extern int     lib.TakeProfit     = 0	;           // 
extern int     lib.StopLoss       = 0	;           //  

extern string  lib.comment      = "";              //  

color lib.clOpenBuy=Red; 
color lib.clOpenSell=Blue;
color lib.clCloseBuy=Red; 
color lib.clCloseSell=Blue;

int lib.Multi=1;


#include <stdlib.mqh>

//+------------------------------------------------------------------+
//|                        |
//|                                Copyright  2010, Victor Nicolaev |
//|                                            e-mail: vinin@mail.ru |
//+------------------------------------------------------------------+
int lib.IdTimeFrame(int lPeriod=0){
   int res=-1;
   int TimeFrame[]={ PERIOD_M1, PERIOD_M5, PERIOD_M15, PERIOD_M30, PERIOD_H1, PERIOD_H4, PERIOD_D1, PERIOD_W1, PERIOD_MN1};
   if (lPeriod==0) lPeriod=Period();
   res=ArrayBsearch( TimeFrame, lPeriod, WHOLE_ARRAY, 0, MODE_ASCEND);
   return(res);

}

//+------------------------------------------------------------------+
//|                                         |
//|                                Copyright  2010, Victor Nicolaev |
//|                                            e-mail: vinin@mail.ru |
//+------------------------------------------------------------------+
//| bool NevBar(int lPeriod=0)                                       |
//+------------------------------------------------------------------+
bool lib.NevBar(int lPeriod=0) { 
   static int PrevTime[]={0,0,0,0,0,0,0,0,0};
   int Id=lib.IdTimeFrame(lPeriod);
   if (Id==-1) return(false);
   if (PrevTime[Id]==iTime(NULL,lPeriod,0)) return(false);
   PrevTime[Id]=iTime(NULL,lPeriod,0);
   return(true);
} 



//+------------------------------------------------------------------+
//|             |
//|                                Copyright  2010, Victor Nicolaev |
//|                                            e-mail: vinin@mail.ru |
//+------------------------------------------------------------------+
//| int Order_Count[6];                                              |
//+------------------------------------------------------------------+
int lib.Order_Count[6];

//+------------------------------------------------------------------+
//|             |
//|                                       |
//|                                Copyright  2010, Victor Nicolaev |
//|                                            e-mail: vinin@mail.ru |
//+------------------------------------------------------------------+
//| int Order_Count_Calculate(string lSymbol, int lMagic, int lOP=-1)|
//+------------------------------------------------------------------+
int lib.Order_Count_Calculate(string lSymbol, int lMagic, int lOP=-1){
   ArrayInitialize(lib.Order_Count,0);
   for (int i = OrdersTotal() - 1;  i >= 0;  i--) {
      if (!OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) continue;
      if (OrderSymbol() != lSymbol)                   continue;
      if (OrderMagicNumber() != lMagic)                continue;
      lib.Order_Count[OrderType()]++;
   }
   if (lOP!=-1) return(lib.Order_Count[lOP]);
   return(0);
}
//+------------------------------------------------------------------+
//|                   |
//|                                Copyright  2010, Victor Nicolaev |
//|                                            e-mail: vinin@mail.ru |
//+------------------------------------------------------------------+
//| string NameOP[]={"BUY",                                          |
//|                  "SELL",                                         |
//|                  "BUYLIMMIT",                                    |
//|                  "SELLLIMIT",                                    |
//|                  "BUYSTOP",                                      |
//|                  "SELLSTOP"};                                    |
//+------------------------------------------------------------------+
string lib.NameOP[]={"BUY","SELL","BUYLIMMIT","SELLLIMIT","BUYSTOP","SELLSTOP"};

//+------------------------------------------------------------------+
//|                                      |
//|                       (  ,    ) | 
//|                                Copyright  2010, Victor Nicolaev |
//|                                            e-mail: vinin@mail.ru |
//+------------------------------------------------------------------+
//| void Order_Open(string lSymbol, int lMagic, int lOP);            |
//+------------------------------------------------------------------+
void lib.Order_Open(string lSymbol, int lMagic, int lOP){
   lib.Order_Count_Calculate(lSymbol, lMagic, lOP);
   if (lib.Order_Count[lOP]==0) lib.Order_Open_Next(lSymbol, lMagic, lOP);

}

//+------------------------------------------------------------------+
//|                                |
//|                        (   ) |
//|                       (  ,    ) | 
//|                                Copyright  2010, Victor Nicolaev |
//|                                            e-mail: vinin@mail.ru |
//+------------------------------------------------------------------+
//| void Order_Open_Reversi(string lSymbol, int lMagic, int lOP);    |
//+------------------------------------------------------------------+
void lib.Order_Open_Reversi(string lSymbol, int lMagic, int lOP){
   lib.Order_Count_Calculate(lSymbol, lMagic, lOP);
   int oOP=MathAbs(lOP-1);
   if (lib.Order_Count[oOP]>0)  lib.Order_Close(lSymbol, lMagic, oOP);
   if (lib.Order_Count[lOP]==0) lib.Order_Open_Next(lSymbol, lMagic, lOP);
}

//+------------------------------------------------------------------+
//|                          |
//|                             (   , |
//|                                        ) |
//|                                Copyright  2010, Victor Nicolaev |
//|                                            e-mail: vinin@mail.ru |
//+------------------------------------------------------------------+
//| void Order_Open_Next(int lMagic, int lOP);                       |
//+------------------------------------------------------------------+
void lib.Order_Open_Next(string lSymbol, int lMagic, int lOP){
   int err=GetLastError();
   RefreshRates();
   int cmd=lib.iif(lOP==OP_BUY,1,-1);
   double _ask       = MarketInfo(lSymbol,MODE_ASK);
   double _bid       = MarketInfo(lSymbol,MODE_BID);
   double _point     = MarketInfo(lSymbol,MODE_POINT);
   double _digits    = MarketInfo(lSymbol,MODE_DIGITS);
   double _stoplevel = MarketInfo(lSymbol,MODE_STOPLEVEL);
   double _spred=(_ask-_bid)/_point;
   double price= lib.iif(lOP==OP_BUY,_bid,_ask);
   
   double _tp=0;
   if (lib.TakeProfit>0) {
      _tp=NormalizeDouble(price+cmd*lib.TakeProfit*_point,_digits);
      if (_stoplevel > lib.TakeProfit)
         _tp=NormalizeDouble(price+cmd*_stoplevel*_point,_digits);
   }
   double _sl=0;
   if (lib.StopLoss>0) {
      _sl=NormalizeDouble(price-cmd*lib.StopLoss*_point,_digits);
      if (_stoplevel > lib.StopLoss)
         _sl=NormalizeDouble(price-cmd*_stoplevel*_point,_digits);
   }
   price= lib.iif(lOP==OP_BUY,_ask,_bid);
   if (OrderSend(Symbol(), lOP,  lib.CalculateLots(lSymbol), price, _spred, _sl,_tp,lib.comment,lMagic, 0)==-1) { 
      err=GetLastError();
      Print(lib.fMyErDesc(err));
   }
}
//+------------------------------------------------------------------+
//|                                            |
//|                                Copyright  2010, Victor Nicolaev |
//|                                            e-mail: vinin@mail.ru |
//+------------------------------------------------------------------+
//| void Order_Close(int lMagic, int lOP=-1);                        |
//+------------------------------------------------------------------+
bool lib.Order_Delete(string lSymbol, int lMagic, int lOP=-1){
   bool Res=0;
   int err=GetLastError();
   if (lOP==OP_BUY && lOP==OP_SELL) return(false);
   
   for (int pos=0;pos<OrdersTotal();pos++) {
      if (!OrderSelect(pos,SELECT_BY_POS))   continue;
      if (OrderSymbol()!=lSymbol)            continue;
      if (OrderMagicNumber()!=lMagic)        continue;
      if (OrderType()!=lOP && lOP>=0)        continue;
      Res=OrderDelete(OrderTicket());
      if (!Res) {
         err=GetLastError();
         Print(lib.fMyErDesc(err));
      }
   }
   return(Res);
}


//+------------------------------------------------------------------+
//|                                            |
//|                                Copyright  2010, Victor Nicolaev |
//|                                            e-mail: vinin@mail.ru |
//+------------------------------------------------------------------+
//| void Order_Close(int lMagic, int lOP=-1);                        |
//+------------------------------------------------------------------+
bool lib.Order_Close(string lSymbol, int lMagic, int lOP=-1){
   bool Res=0;
   int err=GetLastError();
   double Spred=(Ask-Bid)/Point*lib.Multi;
   for (int pos=0;pos<OrdersTotal();pos++) {
      if (!OrderSelect(pos,SELECT_BY_POS))               continue;
      if (OrderSymbol()!=lSymbol)                        continue;
      if (OrderMagicNumber()!=lMagic)                    continue;
      if (OrderType()!=OP_BUY && OrderType()!=OP_SELL)   continue;
      if (OrderType()!=lOP && lOP!=-1)                   continue;
      
      Res=OrderClose(OrderTicket(), OrderLots(), OrderClosePrice(), Spred);
      if (!Res) {
         err=GetLastError();
         Print(lib.fMyErDesc(err));
      }
   }
   return(Res);
}


//+------------------------------------------------------------------+
//|                                       |
//|                                Copyright  2010, Victor Nicolaev |
//|                                            e-mail: vinin@mail.ru |
//+------------------------------------------------------------------+
//| double iif(bool A, double B, double C);                          |
//+------------------------------------------------------------------+
double lib.iif(bool A, double B, double C) {if(A) return(B); return(C); }

//+------------------------------------------------------------------+
//|                                       |
//|                                Copyright  2010, Victor Nicolaev |
//|                                            e-mail: vinin@mail.ru |
//+------------------------------------------------------------------+
//| double Calculate_Lots();                                         |
//+------------------------------------------------------------------+

double lib.CalculateLots(string lSymbol){
   double dLot = lib.Lots;
   double dLot_Min  = MarketInfo(lSymbol, MODE_MINLOT);
   double dLot_Max  = MarketInfo(lSymbol, MODE_MAXLOT);

   if (lib.Risk > 0) {
      double dLot_Step = MarketInfo(lSymbol, MODE_LOTSTEP);
      double dLot_Mg   = MarketInfo(lSymbol, MODE_MARGINREQUIRED);
      dLot=MathRound(AccountFreeMargin()*lib.Risk/(dLot_Mg*100.0*dLot_Step))*dLot_Step;
   }
   dLot=MathMax(dLot_Min, MathMin(dLot_Max, dLot));
   return(dLot);

}

//+------------------------------------------------------------------+
//|                             |
//|                                Copyright  2010, Victor Nicolaev |
//|                                            e-mail: vinin@mail.ru |
//+------------------------------------------------------------------+
extern string  lib.sD="     ( )";
extern int     lib.DayStart      =       -1;
extern int     lib.DayStop       =       -1;

//+------------------------------------------------------------------+
//|                             |
//|                                Copyright  2010, Victor Nicolaev |
//|                                            e-mail: vinin@mail.ru |
//+------------------------------------------------------------------+
//| bool CheckDay();                                                 |
//+------------------------------------------------------------------+
bool lib.CheckDay(){
   int CurrentDay=TimeDayOfWeek(Time[0]);
   if (lib.DayStart==-1 || lib.DayStop==-1) return(true);
   if (lib.DayStart == lib.DayStop)
      if(CurrentDay==lib.DayStart) 
         return(true);
   if (lib.DayStart<lib.DayStop)
      if (lib.DayStart<=CurrentDay)
         if (CurrentDay<=lib.DayStop) 
            return(true);
   if (lib.DayStart>lib.DayStop)
      if (lib.DayStart>=CurrentDay || CurrentDay<=lib.DayStop) 
         return(true);
   return(false);
}


//+------------------------------------------------------------------+
//|                             |
//|                                Copyright  2010, Victor Nicolaev |
//|                                            e-mail: vinin@mail.ru |
//+------------------------------------------------------------------+
extern string lib.sH="     ( )";
extern int     lib.HourStart      =       -1;
extern int     lib.HourStop       =       -1;

//+------------------------------------------------------------------+
//|                             |
//|                                Copyright  2010, Victor Nicolaev |
//|                                            e-mail: vinin@mail.ru |
//+------------------------------------------------------------------+
//| bool CheckHour();                                                |
//+------------------------------------------------------------------+
bool lib.CheckHour(){
   int CurrentHour=TimeHour(Time[0]);
   if (lib.HourStart==-1 || lib.HourStop==-1) return(true);
   if (lib.HourStart == lib.HourStop)
      if(CurrentHour==lib.HourStart) 
         return(true);
   if (lib.HourStart<lib.HourStop)
      if (lib.HourStart<=CurrentHour)
         if (CurrentHour<=lib.HourStop) 
            return(true);
   if (lib.HourStart>lib.HourStop)
      if (lib.HourStart>=CurrentHour || CurrentHour<=lib.HourStop) 
         return(true);
   return(false);
}

//+------------------------------------------------------------------+
//|                                            |
//|                                       |
//|                                Copyright  2010, Victor Nicolaev |
//|                                            e-mail: vinin@mail.ru |
//+------------------------------------------------------------------+
//| double Order_Profit_All(string lSymbol, int lMagic=0, int lOP=-1)|
//+------------------------------------------------------------------+
double lib.Order_Profit_All(string lSymbol, int lMagic=0, int lOP=-1){
   double Res=0;
   for (int i = OrdersTotal() - 1;  i >= 0;  i--) {
      if (!OrderSelect(i, SELECT_BY_POS, MODE_TRADES))   continue;
      if (OrderSymbol() != lSymbol)                      continue;
      if (OrderMagicNumber() != lMagic && lMagic!=0)     continue;
      if (OrderType()!=lOP && lOP!=-1)                   continue;
      Res+=(OrderProfit()+OrderSwap()+OrderCommission());
   }
   return(Res);
}

//+------------------------------------------------------------------+
//|                                             |
//|                                        Copyright  2010, Integer |
//+------------------------------------------------------------------+
//| string fMyErDesc(int aErrNum);                                   |
//+------------------------------------------------------------------+

string lib.fMyErDesc(int aErrNum){
   string pref="Err Num: "+aErrNum+" - ";
   switch(aErrNum){
      case    0: return(pref+"NO ERROR"                              );
      case    1: return(pref+"NO RESULT"                             );
      case    2: return(pref+"COMMON ERROR"                          );
      case    3: return(pref+"INVALID TRADE PARAMETERS"              );
      case    4: return(pref+"SERVER BUSY"                           );
      case    5: return(pref+"OLD VERSION"                           );
      case    6: return(pref+"NO CONNECTION"                         );
      case    7: return(pref+"NOT ENOUGH RIGHTS"                     );
      case    8: return(pref+"TOO FREQUENT REQUESTS"                 );
      case    9: return(pref+"MALFUNCTIONAL TRADE"                   );
      case   64: return(pref+"ACCOUNT DISABLED"                      );
      case   65: return(pref+"INVALID ACCOUNT"                       );
      case  128: return(pref+"TRADE TIMEOUT"                         );
      case  129: return(pref+"INVALID PRICE"                         );
      case  130: return(pref+"INVALID STOPS"                         );                           
      case  131: return(pref+"INVALID TRADE VOLUME"                  );
      case  132: return(pref+"MARKET CLOSED"                         );
      case  133: return(pref+"TRADE DISABLED"                        );
      case  134: return(pref+"NOT ENOUGH MONEY"                      );
      case  135: return(pref+"PRICE CHANGED"                         );
      case  136: return(pref+"OFF QUOTES"                            );
      case  137: return(pref+"BROKER BUSY"                           );
      case  138: return(pref+"REQUOTE"                               );
      case  139: return(pref+"ORDER LOCKED"                          );
      case  140: return(pref+"LONG POSITIONS ONLY ALLOWED"           );
      case  141: return(pref+"TOO MANY REQUESTS"                     );
      case  145: return(pref+"TRADE MODIFY DENIED"                   );
      case  146: return(pref+"TRADE CONTEXT BUSY"                    );
      case  147: return(pref+"TRADE EXPIRATION DENIED"               );
      case  148: return(pref+"TRADE TOO MANY ORDERS"                 );
      //---- mql4 run time errors
      case 4000: return(pref+"NO MQLERROR"                           );
      case 4001: return(pref+"WRONG FUNCTION POINTER"                );
      case 4002: return(pref+"ARRAY INDEX OUT OF RANGE"              );
      case 4003: return(pref+"NO MEMORY FOR FUNCTION CALL STACK"     );
      case 4004: return(pref+"RECURSIVE STACK OVERFLOW"              );
      case 4005: return(pref+"NOT ENOUGH STACK FOR PARAMETER"        );
      case 4006: return(pref+"NO MEMORY FOR PARAMETER STRING"        );
      case 4007: return(pref+"NO MEMORY FOR TEMP STRING"             );
      case 4008: return(pref+"NOT INITIALIZED STRING"                );
      case 4009: return(pref+"NOT INITIALIZED ARRAYSTRING"           );
      case 4010: return(pref+"NO MEMORY FOR ARRAYSTRING"             );
      case 4011: return(pref+"TOO LONG STRING"                       );
      case 4012: return(pref+"REMAINDER FROM ZERO DIVIDE"            );
      case 4013: return(pref+"ZERO DIVIDE"                           );
      case 4014: return(pref+"UNKNOWN COMMAND"                       );
      case 4015: return(pref+"WRONG JUMP"                            );
      case 4016: return(pref+"NOT INITIALIZED ARRAY"                 );
      case 4017: return(pref+"DLL CALLS NOT ALLOWED"                 );
      case 4018: return(pref+"CANNOT LOAD LIBRARY"                   );
      case 4019: return(pref+"CANNOT CALL FUNCTION"                  );
      case 4020: return(pref+"EXTERNAL EXPERT CALLS NOT ALLOWED"     );
      case 4021: return(pref+"NOT ENOUGH MEMORY FOR RETURNED STRING" );  
      case 4022: return(pref+"SYSTEM BUSY"                           );                            
      case 4050: return(pref+"INVALID FUNCTION PARAMETERS COUNT"     );
      case 4051: return(pref+"INVALID FUNCTION PARAMETER VALUE"      );
      case 4052: return(pref+"STRING FUNCTION INTERNAL ERROR"        );
      case 4053: return(pref+"SOME ARRAY ERROR"                      ); 
      case 4054: return(pref+"INCORRECT SERIES ARRAY USING"          ); 
      case 4055: return(pref+"CUSTOM INDICATOR ERROR"                );
      case 4056: return(pref+"INCOMPATIBLE ARRAYS"                   );
      case 4057: return(pref+"GLOBAL VARIABLES PROCESSING ERROR"     );
      case 4058: return(pref+"GLOBAL VARIABLE NOT FOUND"             ); 
      case 4059: return(pref+"FUNCTION NOT ALLOWED IN TESTING MODE"  );
      case 4060: return(pref+"FUNCTION NOT CONFIRMED"                );
      case 4061: return(pref+"SEND MAIL ERROR"                       );
      case 4062: return(pref+"STRING PARAMETER EXPECTED"             );
      case 4063: return(pref+"INTEGER PARAMETER EXPECTED"            );
      case 4064: return(pref+"DOUBLE PARAMETER EXPECTED"             );
      case 4065: return(pref+"ARRAY AS PARAMETER EXPECTED"           );
      case 4066: return(pref+"HISTORY WILL UPDATED"                  );
      case 4067: return(pref+"TRADE ERROR"                           );
      case 4099: return(pref+"END OF FILE"                           );
      case 4100: return(pref+"SOME FILE ERROR"                       );
      case 4101: return(pref+"WRONG FILE NAME"                       );
      case 4102: return(pref+"TOO MANY OPENED FILES"                 );
      case 4103: return(pref+"CANNOT OPEN FILE"                      );
      case 4104: return(pref+"INCOMPATIBLE ACCESS TO FILE"           );
      case 4105: return(pref+"NO ORDER SELECTED"                     );
      case 4106: return(pref+"UNKNOWN SYMBOL"                        );
      case 4107: return(pref+"INVALID PRICE PARAM"                   );
      case 4108: return(pref+"INVALID TICKET"                        );
      case 4109: return(pref+"TRADE NOT ALLOWED"                     );
      case 4110: return(pref+"LONGS  NOT ALLOWED"                    );
      case 4111: return(pref+"SHORTS NOT ALLOWED"                    );
      case 4200: return(pref+"OBJECT ALREADY EXISTS"                 );
      case 4201: return(pref+"UNKNOWN OBJECT PROPERTY"               );
      case 4202: return(pref+"OBJECT DOES NOT EXIST"                 );
      case 4203: return(pref+"UNKNOWN OBJECT TYPE"                   );
      case 4204: return(pref+"NO OBJECT NAME"                        );
      case 4205: return(pref+"OBJECT COORDINATES ERROR"              );
      case 4206: return(pref+"NO SPECIFIED SUBWINDOW"                );
      case 4207: return(pref+"SOME OBJECT ERROR"                     );      
      
      default:   return(pref+"WRONG ERR NUM"                         );
   }
}  

